---------------------------------------------------------------
--                                                           
--  PENCIL AND PAPER INTERPRETER
--  By: Martin Carlisle and Al White     
--                                                           
--  PENCIL_PAPER.ADB 
--  Description : Main procedure 
--                       
--  By: Martin Carlisle
--                                         
-- PENCIL AND PAPER INTERPRETER is free software; you can redistribute 
-- it and/or modify it without restriction.  However, we ask that you
-- please retain the original author information, and clearly  
-- indicate if it has been modified.
--  
-- PENCIL AND PAPER INTERPRETER is distributed in the hope that it will 
-- be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
--
---------------------------------------------------------------
with Main_Window;
with Ada.Exceptions;
with Mcc.Gui.Container.Window;
with Mcc.Common_Dialogs;
with File_Menu;
with Simulation_GUI;
with Pencil_Paper_Helpers;
with Ada.Command_Line;
use Ada.Command_Line;

procedure Pencil_Paper is

begin
   Main_Window.Generate_Window;
   Simulation_Gui.Initialize;
   
   -- set minimum window size
   Mcc.Gui.Container.Window.Set_Resize_Handler(
      Obj     => main_Window.main_Window'access,
      Handler => Pencil_Paper_Helpers.Window_Resize_Handler'access);
   if Argument_Count = 1 then
      File_Menu.Open_File(Argument(1));
   end if;

   Mcc.Gui.Container.Window.Set_Close_Handler(
      Obj     => Main_Window.Main_Window'access,
      Handler => File_Menu.Exit_Choice'access);
   Mcc.Gui.Container.Window.Event_Loop;
exception when E:others =>
   Mcc.Common_Dialogs.OK_Box(
      "Uncaught exception -- contact author:" &
      Ada.Exceptions.Exception_Information(E));
   raise;
end Pencil_Paper;