-- Auto generated by RAPID
-- By: Martin C. Carlisle and W. Blair Watkinson II

with Pencil_And_Paper_Computer;
with Read_Dialog;


with Mcc.Gui.Fonts;

package body read_dialog_window is

   procedure Generate_Window is
   begin

      if Mcc.Gui.Container.Window.Is_Open(Mcc.Gui.Container.Window.Window(read_dialog_window)) then
         raise Already_Open;
      end if;

      Mcc.Gui.Container.Window.Create(
         Obj    => read_dialog_window,
         X      => 0,
         Y      => 0,
         Width  => 239,
         Height => 111);

      Mcc.Gui.Container.Window.Set_Title(
         Obj   => read_dialog_window,
         Title => "Enter Value");


      Mcc.Gui.Widget.Label.Create(
         Obj     => label1,
         Parent  => read_dialog_window,
         X       => 8,
         Y       => 9,
         Width   => 213,
         Height  => 15,
         Justify => Mcc.Gui.Widget.Label.left,
         Text    => "Enter decimal value (0-255)");
      Mcc.Gui.Widget.Label.Set_Foreground_Color(
         Obj       => label1,
         New_Color => Mcc.Gui.Colors.Named_Color(
            Mcc.Gui.Colors.black));
      Mcc.Gui.Widget.Text_Entry.Create(
         Obj    => Value_Text,
         Parent => read_dialog_window,
         X      => 16,
         Y      => 29,
         Width  => 202,
         Height => 25);
      Mcc.Gui.Widget.Button.Text.Create(
         Obj    => ok_button,
         Parent => read_dialog_window,
         X      => 85,
         Y      => 72,
         Width  => 52,
         Height => 24,
         Text   => "OK");
      Mcc.Gui.Widget.Button.Set_Push_Callback(
         Obj      => ok_button'access,
         Callback => Read_Dialog.Ok'access);

   end Generate_Window;


   procedure Fill_Window is
   begin
      null; -- in case there aren't any widgets to fill
      Mcc.Gui.Widget.Text_Entry.Set_Text(
         Obj      => Value_Text,
         Text   => Integer(Read_Dialog.Value));

   end Fill_Window;

   procedure Generate_and_Fill_Window is
   begin
       Generate_Window;
       Fill_Window;
   end Generate_and_Fill_Window;

   procedure Read_Window(
         Success         :    out Boolean;
         Highlight_Error : in     Boolean := True;
         Beep_On_Error   : in     Boolean := True) is
   begin
      Success := True;
      declare
         X : Integer := Mcc.Gui.Widget.Text_Entry.Get_Text(
            Obj => Value_Text);
      begin
         Read_Dialog.Value := Pencil_And_Paper_Computer.Memory_Value(X);
      exception when Constraint_Error =>
         if Highlight_Error then
            Mcc.Gui.Widget.Text_Entry.Highlight(Value_Text);
         end if;
         raise;
      end;
   exception when others =>
      Success := False;
      if Beep_On_Error then
         Mcc.Gui.Bell;
      end if;
   end Read_Window;

   procedure Close_Window is
   begin
      Mcc.Gui.Destroy(Mcc.Gui.Object(read_dialog_window));
   end Close_Window;


end read_dialog_window;
